# coding=utf-8
# THIS ADD-ON WAS CREATED BY ROB AKA @KODI_KODER
# THIS ADDON WILL ALLOW YOU TO VIEW YOUR SATALITE CHANNELS
# FROM YOUR AMIKO A3 HYBRID BOX ON OTHER DEVICES CONNECTED
# TO THE SAME LAN NETWORK BY WIFI OR WIRE THIS ADD-ON DOES
# NOT PROVIDE FREE CHANNELS OR PAID CHANNELS AND WE WILL
# NOT TELL YOU HOW TO GET THEM SORRY.
import os
import sys
import urlparse
#import plugintools
import urllib2
import json
import urllib
import xbmcaddon
addon_id = 'plugin.video.amikodi'
selfAddon = xbmcaddon.Addon(id=addon_id)

def get_base_url():
    ip= selfAddon.getSetting('ip')
    return 'http://'+ip+'/'

# ---------------------------------------------------------------------------------------------------------
#  Get most viewed
# ---------------------------------------------------------------------------------------------------------
def get_most_viewed():
    ##plugintools.log("amiko.api.get_most_viewed")

    # Service call
    service_url = get_base_url()+"GET%20NOWORNEXT%20EPG%20%7B%20%22count%22%20%3A%20%2230%22%2C%20%22group%22%20%3A%20%220%22%2C%20%22epgNowOrNextFlag%22%20%3A%20%221%22%2C%20%22startIdx%22%20%3A%20%220%22%20%7D"
    body =urllib2.urlopen(service_url).read()

    # Response parsing
    #plugintools.log("amiko.api.get_most_viewed body="+repr(body))
    items = parse_list(body)
    #plugintools.log("amiko.api.get_most_viewed items="+repr(items))

    return items
	
# ---------------------------------------------------------------------------------------------------------
#  Get hd channels
# ---------------------------------------------------------------------------------------------------------
def get_hd_channels():
    #plugintools.log("amiko.api.get_hd_channels")

    # Service call
    service_url = get_base_url()+"GET%20NOWORNEXT%20EPG%20%7B%20%22count%22%20%3A%20%221000%22%2C%20%22group%22%20%3A%20%225%22%2C%20%22epgNowOrNextFlag%22%20%3A%20%221%22%2C%20%22startIdx%22%20%3A%20%220%22%20%7D"
    body =urllib2.urlopen(service_url).read()

    # Response parsing
    #plugintools.log("amiko.api.get_hd_channels body="+repr(body))
    items = parse_list(body)
    #plugintools.log("amiko.api.get_hd_channels items="+repr(items))

    return items
	
# ---------------------------------------------------------------------------------------------------------
#  Get all channels
# ---------------------------------------------------------------------------------------------------------
def get_all_channels():
    #plugintools.log("amiko.api.get_all_channels")

    # Service call
    service_url = get_base_url()+"GET%20NOWORNEXT%20EPG%20%7B%20%22count%22%20%3A%20%221000%22%2C%20%22group%22%20%3A%20%226%22%2C%20%22epgNowOrNextFlag%22%20%3A%20%221%22%2C%20%22startIdx%22%20%3A%20%220%22%20%7D"
    body =urllib2.urlopen(service_url).read()

    # Response parsing
    #plugintools.log("amiko.api.get_all_channels body="+repr(body))
    items = parse_list(body)
    #plugintools.log("amiko.api.get_all_channels items="+repr(items))

    return items
	
# ---------------------------------------------------------------------------------------------------------
#  Get fav_menu
# ---------------------------------------------------------------------------------------------------------
def get_fav_menu():
    #plugintools.log("amiko.api.get_fav_menu")

    # Service call
    service_url = get_base_url()+"GET%20GROUP%20LIST%201"
    body =urllib2.urlopen(service_url).read()

    # Response parsing
    #plugintools.log("amiko.api.get_fav_menu body="+repr(body))
    items = parse_fav(body)
    #plugintools.log("amiko.api.get_fav_menu items="+repr(items))

    return items
	
# ---------------------------------------------------------------------------------------------------------
#  Get fav_menu_list
# ---------------------------------------------------------------------------------------------------------
def get_fav_menu_list(fav_number,ch_count):
    #plugintools.log("amiko.api.get_fav_menu_list")

    # Service call
    service_url = get_base_url()+"GET%20NOWORNEXT%20EPG%20%7B%20%22count%22%20%3A%20%22"+ch_count+"%22%2C%20%22group%22%20%3A%20%221%22%2C%20%22epgNowOrNextFlag%22%20%3A%20%221%22%2C%20%22startIdx%22%20%3A%20%220%22%2C%22favNo%22%20%3A%20%22"+fav_number+"%22%20%7D"
    body =urllib2.urlopen(service_url).read()

    # Response parsing
    #plugintools.log("amiko.api.get_fav_menu_list body="+repr(body))
    items = parse_list(body)
    #plugintools.log("amiko.api.get_fav_menu_list items="+repr(items))

    return items
	
# ---------------------------------------------------------------------------------------------------------
#  Get sat_menu
# ---------------------------------------------------------------------------------------------------------
def get_sat_menu():
    #plugintools.log("amiko.api.get_sat_menu")

    # Service call
    service_url = get_base_url()+"GET%20GROUP%20LIST%202"
    body =urllib2.urlopen(service_url).read()

    # Response parsing
    #plugintools.log("amiko.api.get_sat_menu body="+repr(body))
    items = parse_sat(body)
    #plugintools.log("amiko.api.get_sat_menu items="+repr(items))

    return items
	
# ---------------------------------------------------------------------------------------------------------
#  Get sat_menu_list
# ---------------------------------------------------------------------------------------------------------
def get_sat_menu_list(sat_number,ch_count):
    #plugintools.log("amiko.api.get_sat_menu_list")

    # Service call
    service_url = get_base_url()+"GET%20NOWORNEXT%20EPG%20%7B%20%22count%22%20%3A%20%22"+ch_count+"%22%2C%20%22group%22%20%3A%20%222%22%2C%20%22epgNowOrNextFlag%22%20%3A%20%221%22%2C%20%22startIdx%22%20%3A%20%220%22%2C%22satNo%22%20%3A%20%22"+sat_number+"%22%20%7D"
    body =urllib2.urlopen(service_url).read()

    # Response parsing
    #plugintools.log("amiko.api.get_sat_menu_list body="+repr(body))
    items = parse_list(body)
    #plugintools.log("amiko.api.get_sat_menu_list items="+repr(items))

    return items
	
# ---------------------------------------------------------------------------------------------------------
#  Get providers
# ---------------------------------------------------------------------------------------------------------
def get_providers():
    #plugintools.log("amiko.api.get_providers")

    # Service call
    service_url = get_base_url()+"GET%20GROUP%20LIST%203"
    body =urllib2.urlopen(service_url).read()

    # Response parsing
    #plugintools.log("amiko.api.get_providers body="+repr(body))
    items = parse_providers(body)
    #plugintools.log("amiko.api.get_providers items="+repr(items))

    return items
	
# ---------------------------------------------------------------------------------------------------------
#  Get providers_list
# ---------------------------------------------------------------------------------------------------------
def get_providers_list(prov_number,ch_count):
    #plugintools.log("amiko.api.get_sat_menu_list")

    # Service call
    service_url = get_base_url()+"GET%20NOWORNEXT%20EPG%20%7B%20%22count%22%20%3A%20%22"+ch_count+"%22%2C%20%22group%22%20%3A%20%223%22%2C%20%22epgNowOrNextFlag%22%20%3A%20%221%22%2C%20%22startIdx%22%20%3A%20%220%22%2C%22providerNo%22%20%3A%20%22"+prov_number+"%22%20%7D"
    body =urllib2.urlopen(service_url).read()

    # Response parsing
    #plugintools.log("amiko.api.get_sat_menu_list body="+repr(body))
    items = parse_list(body)
    #plugintools.log("amiko.api.get_sat_menu_list items="+repr(items))

    return items
	
# ---------------------------------------------------------------------------------------------------------
#  set stream
# ---------------------------------------------------------------------------------------------------------
def set_stream(code):
    #plugintools.log("amiko.api.set_stream")

    # Service call
    service_url = get_base_url()+"SET%20CHANNEL%20"+code+"%201%200"
    body =urllib2.urlopen(service_url).read()

# ---------------------------------------------------------------------------------------------------------
#  chnnel search
# ---------------------------------------------------------------------------------------------------------	
def channel_search(terms):
    #plugintools.log("hdtv.api.channel_search")

    # Service call
    service_url = get_base_url()+"GET%20KEYWORD%20EPGLIST%20%7B%20%22count%22%20%3A%20%22100%22%2C%20%22group%22%20%3A%200%2C%20%22epgNowOrNextFlag%22%20%3A%20%221%22%2C%20%22startIdx%22%20%3A%20%220%22%2C%22keyWord%22%20%3A%20%22"+terms+"%22%7D"
    body =urllib2.urlopen(service_url).read()

    # Response parsing
    #plugintools.log("amiko.api.channel_search body="+repr(body))
    items = parse_list(body)
    #plugintools.log("amiko.api.channel_search items="+repr(items))

    return items
	
# ---------------------------------------------------------------------------------------------------------
#  parsers
# ---------------------------------------------------------------------------------------------------------

def parse_list(body):

    raw_body =  body.replace("200 {", "{")
    #plugintools.log("amiko.api.parse_list raw_body="+repr(raw_body))
    channels = json.loads(raw_body)

    items = []
    for channel in channels["data"]:
        item = {}
        item["title"] = channel['channelName']
        item["thumbnail"] = channel['logo']
        item["url"] = channel['channelNo']
        item["plot"] = "AMIKO A3 CHANNEL FROM SATBOX"

        if item["title"]!="" and item["url"]!="":
            items.append(item)

    return items

def parse_fav(body):

    raw_body =  body.replace("200 {", "{")
    #plugintools.log("amiko.api.parse_fav raw_body="+repr(raw_body))
    channels = json.loads(raw_body)

    items = []
    for channel in channels["data"]:
        item = {}
        item["title"] = channel['favName']
        item["url"] = str(channel['favNo'])
        item["plot"] = str(channel['count'])

        if item["title"]!="" and item["url"]!="":
            items.append(item)

    return items
	
def parse_sat(body):

    raw_body =  body.replace("200 {", "{")
    #plugintools.log("amiko.api.parse_sat raw_body="+repr(raw_body))
    channels = json.loads(raw_body)

    items = []
    for channel in channels["data"]:
        item = {}
        item["title"] = channel['satName']
        item["url"] = str(channel['satNo'])
        item["plot"] = str(channel['count'])

        if item["title"]!="" and item["url"]!="":
            items.append(item)

    return items
	
def parse_providers(body):

    raw_body =  body.replace("200 {", "{")
    #plugintools.log("amiko.api.parse_providers raw_body="+repr(raw_body))
    channels = json.loads(raw_body)

    items = []
    for channel in channels["data"]:
        item = {}
        item["title"] = channel['providerName']
        item["url"] = str(channel['providerNo'])
        item["plot"] = str(channel['count'])

        if item["title"]!="" and item["url"]!="":
            items.append(item)

    return items
