import xbmc,xbmcaddon,xbmcgui,xbmcplugin,os,sys,urlparse,api,re,time,urllib,urllib2,json
import pyxbmct.addonwindow as pyxbmct

addon_id = 'plugin.video.amikodi'
selfAddon = xbmcaddon.Addon(id=addon_id)
icon = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'icon.png'))
button_quit_no_focus = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id + '/resources/art', 'quit_no_focus.png'))
button_quit_focus = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id + '/resources/art', 'quit_focus2.png'))

button_focus = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id + '/resources/art', 'button_focus.png'))
button_no_focus = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id + '/resources/art', 'button_no_focus.png'))
bg = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id + '/resources/art', 'bg7.jpg'))
ip= selfAddon.getSetting('ip')
port= selfAddon.getSetting('port')
window  = pyxbmct.AddonDialogWindow('')
window.setGeometry(1240, 650, 100, 50)
background=pyxbmct.Image(bg)
window.placeControl(background, 0, 0, 120, 51)

if ip == '' :
    dialog = xbmcgui.Dialog()
    ret = dialog.yesno('AMIKOdi', 'You will need to enter the IP address','and port of your amiko device to continue','','Cancel','OK')
    if ret == 1:
        keyb = xbmc.Keyboard('', 'Enter Box IP Address:')
        keyb.doModal()
        if (keyb.isConfirmed()):
            ip = keyb.getText()
            keyb = xbmc.Keyboard('8802', 'Enter Box Port Number (8802 default):')
            keyb.doModal()
            if (keyb.isConfirmed()):
                port = keyb.getText()
                selfAddon.setSetting('ip',ip)
                selfAddon.setSetting('port',port)
                if port=='':quit()
    else:quit()
try:
    url='http://'+ip  
    req = urllib2.Request(url)
    req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3')
    response = urllib2.urlopen(req)
    link=response.read()
    response.close()
except:
    dialog = xbmcgui.Dialog()
    dialog.ok('An Error Has Occured', 'Unable to communicate with your device','Please check your IP and port details')
    quit()
    

def Amiko():
    
    #set globals
    global Favs
    global Sats
    global Prov
    global HD
    global All
    global Search
    global List
    global Icon

    #create butttons
    Favs= pyxbmct.Button('Favourites',focusTexture=button_focus,noFocusTexture=button_no_focus)
    Sats = pyxbmct.Button('Satellites',focusTexture=button_focus,noFocusTexture=button_no_focus)
    Prov = pyxbmct.Button('Providers',focusTexture=button_focus,noFocusTexture=button_no_focus)
    HD = pyxbmct.Button('HD Channels',focusTexture=button_focus,noFocusTexture=button_no_focus)
    All = pyxbmct.Button('All Channels',focusTexture=button_focus,noFocusTexture=button_no_focus)
    Search = pyxbmct.Button('Channel Search',focusTexture=button_focus,noFocusTexture=button_no_focus)
    List = pyxbmct.List(buttonFocusTexture=button_focus,buttonTexture=button_no_focus,_space=11,_itemTextYOffset=-7)
    Icon=pyxbmct.Image(icon)
    Icon.setImage(icon)
    Quit= pyxbmct.Button('',focusTexture=button_quit_focus,noFocusTexture=button_quit_no_focus)


    #place buttins
    window.placeControl(Favs,40, 3,  10, 9)
    window.placeControl(Sats,50, 3, 10, 9)
    window.placeControl(Prov,60, 3, 10, 9)
    window.placeControl(HD,70, 3, 10, 9)
    window.placeControl(All,80, 3, 10, 9)
    window.placeControl(Search,90, 3, 10, 9)
    window.placeControl(List, 40, 15, 70, 15)
    window.placeControl(Icon, 43, 33, 55, 16)
    window.placeControl(Quit,105, 3,  10, 3)

    #button actions
    window.connect(Favs, GET_FAVS_CATS)
    window.connect(Sats, GET_SAT_CATS)
    window.connect(Prov, GET_PROV_CATS)
    window.connect(HD, GET_HD)
    window.connect(All, GET_ALL)
    window.connect(Search, SEARCH)
    window.connect(List, PLAY_STREAM)
    window.connect(Quit, window.close)

    #navigation
    Favs.controlUp(Search)
    Favs.controlDown(Sats)
    Favs.controlRight(List)
    Sats.controlUp(Favs)
    Sats.controlDown(Prov)
    Sats.controlRight(List)
    Prov.controlUp(Sats)
    Prov.controlDown(HD)
    Prov.controlRight(List)
    HD.controlUp(Prov)
    HD.controlDown(All)
    HD.controlRight(List)
    All.controlUp(HD)
    All.controlDown(Search)
    All.controlRight(List)
    Search.controlUp(All)
    Search.controlRight(List)
    Search.controlDown(Quit)
    Quit.controlUp(Search)
    Quit.controlDown(Favs)
    List.controlLeft(Favs)

    window.connectEventList(
	[pyxbmct.ACTION_MOVE_DOWN,
	pyxbmct.ACTION_MOVE_UP,
        pyxbmct.ACTION_MOUSE_MOVE],
	REFRESH)
    window.setFocus(Favs)

def PLAY_STREAM():
    if 'AMIKO' in plot:
        xbmc.executebuiltin('ActivateWindow(10138)')
        set_stream = api.set_stream(url)
        window.close()
        time.sleep(5)
        mediaurl = 'http://'+ip+':'+port+"/"+url+".ts"
        liz=xbmcgui.ListItem(title, iconImage=thumbnail,thumbnailImage=thumbnail)
        xbmc.executebuiltin('Dialog.Close(10138)') 
        xbmc.Player ().play(mediaurl, liz, False)

    elif indicator=='favs':GET_FAVS()
    elif indicator=='provs':GET_PROVS()
    elif indicator=='sats':GET_SATS()
    
def SEARCH():
    global items
    List.reset()
    search_entered =''
    keyboard = xbmc.Keyboard(search_entered, 'Search For Channels')
    keyboard.doModal()
    if keyboard.isConfirmed():
        search_entered = keyboard.getText()
    if len(search_entered)>1:
        items = api.channel_search(search_entered)
        for item in items:
            chan_title=item["title"]
            chan_url=item["url"]
            chan_thumb=item["thumbnail"]
            List.addItem(chan_title)
    else:quit()

def GET_PROVS():
    global items
    List.reset()
    items = items = api.get_providers_list(url,plot)
    for item in items:
        chan_title=item["title"]
        chan_url=item["url"]
        chan_thumb=item["thumbnail"]
        List.addItem(chan_title)
    
def GET_PROV_CATS():
    global items
    global indicator
    indicator='provs'
    List.reset()
    items = api.get_providers()
    for item in items:
        chan_title=item["title"]
        chan_title='> '+chan_title
        chan_url=item["url"]
        chan_thumb=icon
        List.addItem(chan_title)

def GET_SATS():
    global items
    List.reset()
    items = items = api.get_sat_menu_list(url,plot)
    for item in items:
        chan_title=item["title"]
        chan_url=item["url"]
        chan_thumb=item["thumbnail"]
        List.addItem(chan_title)

def GET_SAT_CATS():
    global items
    global indicator
    indicator='sats'
    List.reset()
    items = api.get_sat_menu()
    for item in items:
        chan_title=item["title"]
        chan_title='> '+chan_title
        chan_url=item["url"]
        chan_thumb=icon
        List.addItem(chan_title)

def GET_FAVS():
    global items
    List.reset()
    items = api.get_fav_menu_list(url,plot)
    for item in items:
        chan_title=item["title"]
        chan_url=item["url"]
        chan_thumb=item["thumbnail"]
        List.addItem(chan_title)

def GET_FAVS_CATS():
    global items
    global indicator
    indicator='favs'
    List.reset()
    items = api.get_fav_menu()
    for item in items:
        chan_title=item["title"]
        chan_title='> '+chan_title
        chan_url=item["url"]
        chan_thumb=icon
        List.addItem(chan_title)

def GET_ALL():
    global items
    List.reset()
    items = api.get_all_channels()
    for item in items:
        chan_title=item["title"]
        chan_url=item["url"]
        chan_thumb=item["thumbnail"]
        List.addItem(chan_title)

def GET_HD():
    global items
    List.reset()
    items = api.get_hd_channels()
    for item in items:
        chan_title=item["title"]
        chan_url=item["url"]
        chan_thumb=item["thumbnail"]
        List.addItem(chan_title)

def REFRESH():
    try:
        global url
        global title
        global plot
        global thumbnail
        if window.getFocus() == List:
            pos=List.getSelectedPosition()
            selected=items[pos]
            url = selected["url"]
            title=selected["title"]
            plot=selected["plot"]
            try:
                thumbnail = selected["thumbnail"]
                Icon.setImage(thumbnail)
            except:
                thumbnail=icon
                Icon.setImage(thumbnail)
    except:pass

def addLink(name,url,mode,iconimage,fanart,description=''):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&description="+str(description)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name, 'plot': description } )
        liz.setProperty('fanart_image', fanart)
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=False)
        return ok
Amiko()
window.doModal()
xbmcplugin.endOfDirectory(int(sys.argv[1]))


